#include<gnome.h>
#include<gtk/gtk.h>
#include<sys/asoundlib.h>
#include<applet-widget.h>

#include"pmix_applet.xpm"

gint slidebar;
GdkBitmap *mask;
GtkWidget *applet;
GdkPixmap *pixmap[5];
GtkWidget *pixmap_widget[5];
gchar *current_volume[5][82];

snd_mixer_t *mixer;
snd_mixer_group_t group[5];
snd_mixer_groups_t mixer_groups;

void
set_volume (gint volume)
{
  if (snd_mixer_open (&mixer, 0, 0) != 0)
    g_error ("Can't open mixer!\n");

  snd_mixer_group_read (mixer, &group[slidebar]);
  group[slidebar].volume.names.front_left = volume;
  group[slidebar].volume.names.front_right = volume;
  group[slidebar].volume.names.front_center = volume;
  group[slidebar].volume.names.rear_left = volume;
  group[slidebar].volume.names.rear_right = volume;
  group[slidebar].volume.names.woofer = volume;
  snd_mixer_group_write (mixer, &group[slidebar]);

  snd_mixer_close (mixer);
}

void
draw_slidebar (gint volume)
{
  gint a;
  if (volume < 0 || volume > 40)
    return;

  for (a = 41; a < 81 - volume; a++)
    strcpy (current_volume[slidebar][a], "      ");
  for (a = 81 - volume; a < 82; a++)
    strcpy (current_volume[slidebar][a], volume_slider[a]);

  pixmap[slidebar] = gdk_pixmap_create_from_xpm_d (applet->window, &mask, NULL, (gchar **) current_volume[slidebar]);
  gtk_pixmap_set (GTK_PIXMAP (pixmap_widget[slidebar]), pixmap[slidebar], mask);
  gtk_widget_show (pixmap_widget[slidebar]);

  return;
}

gint
button_press (GtkWidget * widget, GdkEventButton * event, gpointer data)
{
  if (event->x < 6)
    slidebar = 0;
  else if (event->x > 8 && event->x < 15)
    slidebar = 1;
  else if (event->x > 17 && event->x < 24)
    slidebar = 2;
  else if (event->x > 26 && event->x < 33)
    slidebar = 3;
  else if (event->x > 35 && event->x < 42)
    slidebar = 4;
  else
    return TRUE;

  draw_slidebar (40 - event->y);
  set_volume ((40 - event->y) * ((group[slidebar].max - group[slidebar].min) / 40.0));

  return TRUE;
}

gint button_release (GtkWidget * widget, GdkEventButton * event, gpointer data)
{
  slidebar = -1;
  return TRUE;
}

gint
motion_notify (GtkWidget * widget, GdkEventMotion * event, gpointer data)
{
  gint volume;

  if (slidebar == -1)
    return TRUE;

  volume = event->y;
  if (event->y < 0)
    volume = 0;
  if (event->y > 40)
    volume = 40;

  draw_slidebar (40 - volume);
  set_volume ((40 - volume) * ((group[slidebar].max - group[slidebar].min) / 40.0));

  return TRUE;
}

int
main (int argc, char **argv)
{
  gint a, b;
  GtkWidget *fixed;
  GtkWidget *frame;
  snd_mixer_info_t mixer_info;

  applet_widget_init ("pmix_applet", "0.0.1", argc, argv, NULL, 0, NULL);
  applet = applet_widget_new ("pmix_applet");

  if (!applet)
    g_error ("Can't create applet!\n");

  for (a = 0; a < 5; a++)
    for (b = 0; b < 82; b++)
      {
	current_volume[a][b] = malloc (13);
	strcpy (current_volume[a][b], volume_slider[b]);
      }

  fixed = gtk_fixed_new ();

  for (a = 0; a < 5; a++)
    {
      pixmap[a] = gdk_pixmap_create_from_xpm_d (applet->window, &mask, NULL, (gchar **) current_volume[a]);
      pixmap_widget[a] = gtk_pixmap_new (pixmap[a], mask);
      gtk_widget_show (pixmap_widget[a]);
      gtk_fixed_put (GTK_FIXED (fixed), pixmap_widget[a], 9 * a, 0);
    }

  if (snd_mixer_open (&mixer, 0, 0) != 0)
    g_error ("Can't open mixer!\n");

  snd_mixer_info (mixer, &mixer_info);
  mixer_groups.groups_size = mixer_info.groups;
  mixer_groups.pgroups = malloc (mixer_info.groups * sizeof (snd_mixer_gid_t));
  snd_mixer_groups (mixer, &mixer_groups);

  for (a = 0; a < mixer_info.groups; a++)
    {
      if (strcmp (mixer_groups.pgroups[a].name, "Master") == 0)
	{
	  group[0].gid = mixer_groups.pgroups[a];
	  snd_mixer_group_read (mixer, &group[0]);
	}
      if (strcmp (mixer_groups.pgroups[a].name, "PCM") == 0)
	{
	  group[1].gid = mixer_groups.pgroups[a];
	  snd_mixer_group_read (mixer, &group[1]);
	}
      if (strcmp (mixer_groups.pgroups[a].name, "Aux") == 0)
	{
	  group[2].gid = mixer_groups.pgroups[a];
	  snd_mixer_group_read (mixer, &group[2]);
	}
      if (strcmp (mixer_groups.pgroups[a].name, "Line") == 0)
	{
	  group[3].gid = mixer_groups.pgroups[a];
	  snd_mixer_group_read (mixer, &group[3]);
	}
      if (strcmp (mixer_groups.pgroups[a].name, "MIC") == 0)
	{
	  group[4].gid = mixer_groups.pgroups[a];
	  snd_mixer_group_read (mixer, &group[4]);
	}
    }

  snd_mixer_close (mixer);

  for (slidebar = 0; slidebar < 5; slidebar++)
    draw_slidebar (group[slidebar].volume.names.front_left * 40 / (group[slidebar].max - group[slidebar].min));

  slidebar = -1;

  gtk_widget_set_events (fixed, GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK | GDK_POINTER_MOTION_MASK);

  gtk_signal_connect (GTK_OBJECT (fixed), "button_press_event", GTK_SIGNAL_FUNC (button_press), NULL);
  gtk_signal_connect (GTK_OBJECT (fixed), "button_release_event", GTK_SIGNAL_FUNC (button_release), NULL);
  gtk_signal_connect (GTK_OBJECT (fixed), "motion_notify_event", GTK_SIGNAL_FUNC (motion_notify), NULL);

  gtk_widget_show (fixed);

  frame = gtk_frame_new ("Mixer");
  gtk_container_add (GTK_CONTAINER (frame), fixed);
  gtk_widget_show (frame);

  gtk_container_add (GTK_CONTAINER (applet), frame);
  gtk_widget_show (applet);

  applet_widget_gtk_main ();

  return 0;
}
